
import javax.swing.*;
import javax.swing.event.*;

public class TJComboBox1 extends JApplet {
    public void init() {
        // 1. Create a combo box with the custom model.
        JComboBox cbox = new JComboBox(new MyComboBoxModel());

        // 2. Set the number of rows to be visible.
        cbox.setMaximumRowCount(5);

        // 3. Add the combo box object to the applet's content pane.
        getContentPane().add(cbox);
    }
}

// 4. Custom data model for the combo box.
class MyComboBoxModel extends AbstractListModel
                      implements ComboBoxModel {
    String[] ComputerComps = {"Monitor", "Key Board", "Mouse",
                              "Joy Stick", "Modem", "CD ROM",
                              "RAM Chip", "Diskette"};
    String selection = null;

    // Methods implemented from the class AbstractListModel
    public Object getElementAt(int index) {
        return ComputerComps[index];
    }

    public int getSize() {
        return ComputerComps.length;
    }

    public void setSelectedItem(Object anItem) {
        selection = (String) anItem; // to select and register an
    }                                // item from the pull-down list

    // Methods implemented from the interface ComboBoxModel
    public Object getSelectedItem() {
        return selection; // to add the selection to the combo box
    }
}



