import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;

public class TJList extends JApplet {
    // 1. Declare the required references.
    JList list = null;
    JLabel label = null;
    Container c = null;

    // 2. Create the arrays for the list selections.
    String[] weekdays = {
        "Sunday", "Monday", "Tuesday", "Wednesday",
        "Thursday", "Friday", "Saturday" };
    int[] holidays = {0, 6}; //Indices for sunday&saturday

    public void init() {
        // 3. Get the handle on the applet's content pane.
        c = this.getContentPane();

        // 4. Create a list object.
        list = new JList(weekdays);
        Font f1 = new Font("SansSerif", Font.BOLD, 16);
        list.setFont(f1);
        list.setSelectionMode(
             ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
        list.setSelectedIndices(holidays);
        list.addSelectionInterval(2, 4);
        list.setSelectionBackground(Color.blue);
        list.setSelectionForeground(Color.white);

        // 5. Registering a listener class.
        ListSelectionListener l = new MyListener();
        list.addListSelectionListener(l);

        // 6. Add the list to a scroll pane and finally to the applet.
        JScrollPane sp = new JScrollPane(list);
        c.add(sp);

        // 7. Create a label object.
        label = new JLabel("Reselect using mouse?", JLabel.CENTER);
        Font f2 = new Font("Serif", Font.BOLD, 26);
        label.setFont(f2);
        label.setOpaque(true);
        label.setBackground(Color.lightGray);
        label.setForeground(Color.black);
        c.add(label, BorderLayout.SOUTH);
    }

    // 8. JList selection event listener class.
    class MyListener implements ListSelectionListener {
        public void valueChanged(ListSelectionEvent evt) {
            label.setText((String) list.getSelectedValue());
        }
    }
}

