import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

public class TJRadioButton extends JApplet {
    // 1. Declare the object references.
    JRadioButton rButton1, rButton2, rButton3;
    JRadioButton rButton4, rButton5, rButton6;

    JLabel label = null;
    String message = null;
    Font font = null;
    Container container;
    String LF = "com.sun.java.swing.plaf.motif.MotifLookAndFeel";
    public void init() {
        // 2. Set the look-and-feel of the applet to the Motif type.
        try {
            UIManager.setLookAndFeel(LF);
        } catch (Exception e) {
            System.err.println("Look and Feel not Initialized!");
        }
        // 3. Get a handle on the JApplet container.
        container = this.getContentPane();

        // 4. Initialize the font object.
        font = new Font("Serif", Font.PLAIN, 16);

        // 5. Initialize the message.
        message = "Check or Uncheck any Radio Button?";

        // 6. Create grid layout and set it for the JApplet.
        container.setLayout(new GridLayout(2, 1));

        // 7. Create the JRadioButton objects.
        rButton1 = new JRadioButton("Serif", true);
        CustomListener cl = new CustomListener();
        rButton1.addActionListener(cl);

        rButton2 = new JRadioButton("SansSerif");
        rButton2.addActionListener(cl);

        rButton3 = new JRadioButton("Monospaced");
        rButton3.addActionListener(cl);

        // 8. Form a group with these radio buttons.
        ButtonGroup group1 = new ButtonGroup();
        group1.add(rButton1);
        group1.add(rButton2);
        group1.add(rButton3);

        // 9. Create the remaining JRadioButton objects.
        rButton4 = new JRadioButton("Plain", true);
        rButton4.addActionListener(cl);

        rButton5 = new JRadioButton("Bold");
        rButton5.addActionListener(cl);

        rButton6 = new JRadioButton("Italic");
        rButton6.addActionListener(cl);

        // 10. Form a group with these radio buttons.
        ButtonGroup group2 = new ButtonGroup();
        group2.add(rButton4);
        group2.add(rButton5);
        group2.add(rButton6);

        // 11. Create a JPanel and main label objects.
        JPanel panel = new JPanel();
        panel.setLayout(new GridLayout(4, 2));
        Icon picture = new ImageIcon("pointer.gif");
        label = new JLabel(message, picture, SwingConstants.CENTER);

        // 12. Add the radio buttons to JPanel.
        panel.add(new JLabel("Font"));
        panel.add(new JLabel("Font Type"));
        panel.add(rButton1);     panel.add(rButton4);
        panel.add(rButton2);     panel.add(rButton5);
        panel.add(rButton3);     panel.add(rButton6);

        // 13. Add JPanel and canvas to the JApplet.
        container.add(panel);
        container.add(label);
    }

    // 14. The item listener class.
    class CustomListener implements ActionListener {
        public void actionPerformed(ActionEvent evt) {
            JRadioButton rButton = (JRadioButton) evt.getSource();
            if (rButton == rButton1) {
                font  = new Font("Serif", font.getStyle(), 16);
                label.setFont(font);
                label.setText("You selected the SERIF font!");
                container.validate();
            }
            else if (rButton == rButton2) {
                font = new Font("SansSerif", font.getStyle(), 16);
                label.setFont(font);
                label.setText("You selected the SANSSERIF font!");
                container.validate();
            }
            else if (rButton == rButton3) {
                font = new Font("Monospaced", font.getStyle(), 16);
                label.setFont(font);
                label.setText("You selected the MONOSPACED font!");
                container.validate();
            }
            else if (rButton == rButton4) {
                font = new Font(font.getName(), Font.PLAIN, 16);
                label.setFont(font);
                label.setText("You selected the PLAIN style!");
                container.validate();
            }
            else if (rButton == rButton5) {
                font = new Font(font.getName(), Font.BOLD, 16);
                label.setFont(font);
                label.setText("You selected the BOLD style!");
                label.validate();
            }
            else if (rButton == rButton6) {
                font = new Font(font.getName(), Font.ITALIC, 16);
                label.setFont(font);
                label.setText("You selected the ITALIC style!");
                container.validate();
            }
        }
    }
}

