import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class TJTextField extends JApplet {
    Container container;
    JTextField textField1, textField2;

    public void init() {
        // 1. Get the handle on the applet's content pane.
        container = this.getContentPane();

        // 2. Prepare the applet with vertical box layout.
        container.setLayout(new BoxLayout(container, BoxLayout.Y_AXIS));

        // 3. Create two text-fields and a button.
        textField1 = new JTextField(
            "Enter some text here and press return", // Initial string
            20); // 20 columns width
        // Add an action listener to this text field.
        textField1.addActionListener(new TextFieldListener());
        // Assign a line border with black color.
        textField1.setBorder(BorderFactory.createLineBorder(Color.black));

        textField2 = new JTextField(20);   // 20 columns width.
        // Assign a line border with blue color.
        textField2.setBorder(BorderFactory.createLineBorder(Color.blue));

        JButton button = new JButton("Clear");
        // Add an action listener to this button.
        button.addActionListener(new ButtonListener());

        // 4. Add text-fields and button to the applet's content pane.
        container.add(Box.createVerticalGlue()); //Add a glue component.
        container.add(textField1); // Add the textfield1.
        container.add(Box.createVerticalGlue()); // Add another glue component.
        container.add(textField2); // add the textfield2
        container.add(Box.createVerticalGlue()); // Add another glue component.
        container.add(button); // Add the button.
    }

    // 5. The text field listener class.
    class TextFieldListener implements ActionListener {
        public void actionPerformed(ActionEvent e) {
             // Retrieve the text entered in textfield1
             // and assign it the other textfield.
             textField2.setText(e.getActionCommand());
        }
    }

    // 6. The button listener class.
    class ButtonListener implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            // Clear both the text fields.
            textField1.setText("");
            textField1.requestFocus(); // Get the focus back
            textField2.setText("");
        }
    }
}
